# ChangePSsetup.awk		by Petr Mikulik.  Version: 19.3.1998

# This script adds a setup code (for 2 side or Slot 2 printing, for instance), 
# into the specified PS files.
# This setup code is read from the first given file, and it is added after:
#	- %%EndComments  declaration
#	- the %% block of header lines
#	- first blank line (which should not be in a PS file, anyway)

BEGIN {
if (ARGC==1) {
  print "Usage:  awk -f ChangePSsetup.awk  _setup_file_   postscript_file(s)"
  print "where the _setup_file_ is 2sideL.PS, 2sideP.PS etc."
  exit
  }
copy=0
# PSSetupFile="2sideL.PS"
PSSetupFile=ARGV[1]
if (!FileExist(PSSetupFile)) {
  print "Setup file  " PSSetupFile "  with PS code does not exist.\a"
  exit
  }
Out=""
}

ARGIND==1 { nextfile }

# new file
FNR==1 {
  print "Processing " FILENAME "..."
  if (Out!="") close(Out)
  Out="CHPS-"FILENAME
  copy=0
  }

# work on the file
copy { print >Out; next }
FNR==1 { print >Out; next } # document should start with %!, but there can be binary garbage...

NF==0 { AddIt(); next }
substr($1,1,2)!="%%" { tmp=$0; AddIt(); print tmp >Out; next }
$1=="%%EndComments" { print >Out; AddIt(); next }

{ print  >Out }

function AddIt () {
while ( (getline <PSSetupFile)>0 ) print  >Out
close(PSSetupFile)
$0=""
copy=1
}


# FileExist
# return 1 if the specified file exists
function FileExist ( File,   tmp ) {
tmp=(getline <File)
close(File)
# tmp=0 if eof (i.e. null file), +1 if sth has been read
return (tmp>=0)
}


# eof ChangePSsetup
